% K-Means 
%   Algoritmus pro rozdeleni data do N shluku dlemeuklidovske metriky tak
%   aby byla minimalizovana kriterialni funkce J=suma(Ji)=suma(suma(d(x,mi)^2))

% volani KMEANS(data,N,T)
% kde  
%      data je mnozina vsech obrazu ve formatu matice, radek predstavuje
%           jeden element dat. Velikost matice minimalne 2x2
%      N pocet shluku, defaultne nastaven na 2
%      T urcuje typ jak budou vybirany pocatecni shluky T=1,2,3
%         1-vyber prvnich N bodu
%         2-vyber nahodne N bodu

function K=KMEANS(data,T)

% vstupni promene
	if ~exist('data')
        data=[ 0 0; 1 0; 0 1; 1 1;2 1;1 2;2 2;3 2; 6 6;7 6;8 6;6 7;7 7;8 7;9 7;7 8;8 8;9 8;8 9;9 9];
        plot(data(:,1),data(:,2),'x')
	end
	
	if ~exist('N')
        N=2;
	end
	
	if ~exist('T')
        T=1;
	end

%========== KROK 1 - volba pocatecnich stredu
	if T==1 
      MN=PS(data,N,1);  % ziskam stredy, jako prvni N bodu
	else
      MN=PS(data,N,2);  % ziskam stredy nahodne    
	%  MN=NS(T,data);  
	end

    k=0;n=1;
	while k<1
          M=MN; 
%========== KROK 2
          shluk=SH(M,data); % rozdel data do N trid
%========== KROK 3
          MN=NS(shluk,data); % nove stredy
          J=JJ(shluk,data,MN); % kriterialni funkce
          JK(n)=sum(J); n=n+1; % ulozeni kriterialni funkce, pro vypis
%========== KROK 4
          zmena = ZS(MN,M); % doslo ke zmene stredu
          if zmena == 0
              k=1; % konec algoritmu
          end
          % nebo v kroku 4 muzeme kontrolovat zda doslo k poklesu kriterialni funkce pod stanovenou mez
	end
    
end

plot(JK);Title('Prubeh trenovani - kriterialni funkce')